<template>
  <div v-if="isOpen" class="modal-wrap" @click="close">
    <div class="modal" @click.stop>
      <div>
        <slot name="main"></slot>
      </div>
      <div class="modal__footer">
        <slot name="footer" :close="close" :confirm="confirm">
          <base-button @click="close">
            Отмена
          </base-button>

          <base-button @click="confirm">
            Ok
          </base-button>
        </slot>
      </div>
    </div>
  </div>
</template>

<script>
import BaseButton from './BaseButton'
export default {
  components: { BaseButton },
  props: {
    isOpen: {
      type: Boolean,
      required: true,
    },
  },
  mounted() {
    document.addEventListener('keydown', this.handleKeydown);
  },
  unmounted() {
    document.removeEventListener('keydown', this.handleKeydown);
  },
  methods: {
    handleKeydown(e) {
      if (this.isOpen && e.key === 'Escape') {
        this.close();
      }
    },
    close() {
      this.$emit('close');
    },
    confirm() {
      this.$emit('confirm');
    },
  },
};
</script>

<style scoped>
.modal-wrap {
  position: fixed;
  top: 0;
  left: 0;
  bottom: 0;
  right: 0;
  width: 100vw;
  min-height: 100vh;
  background: #020D34BF;
  display: flex;
  z-index: 100;
}
.modal {
  background: white;
  top: 50%;
  padding: 30px 40px 50px;
  left: 50%;
  transform: translate(-50%, -50%);
  position: fixed;
  z-index: 101;
  display: flex;
  border-radius: 6px;
  flex-direction: column;
}
.modal__footer {
  display: flex;
  align-items: center;
  margin-top: auto;
}
</style>
